;; run as `soundscrape sequencer.scm'

(use-modules (soundscrape ui)) ;; make sure we have this loaded...

(define w (gui-window "sequencer example"))

(play
 (audio
  sine ;; a sine wave
  (audio ;; with a frequency modulated by
   sine ;; a sine wave, with its
        ;; frequency and multiplication controlled by slider bars
   (control (slider-control w :upper 20 :lower 0 :value 10 :warp 'linear))
   (control (slider-control w :upper 100 :lower 0 :value 10))
   (audio ;; and added to an audio-rate
    sequencer ;; sequencer
    (let ((v #(55 57 58 60 62 64 65 67)))
      (lambda () ;; a function to pick out a random midi note and return it in Hz
        (midi->cps (vector-ref v (random (vector-length v))))))
    (audio ;; with the sequencer clock
     impulse ;; coming from an impulse generator at a slider-controlled frequency
     (control (slider-control w :upper 20 :lower 1 :value 10 :warp 'exponential)))))))
