;; Soundscrape
;; Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>

;; This program is free software; you can redistribute it and/or    
;; modify it under the terms of the GNU General Public License as   
;; published by the Free Software Foundation; either version 2 of   
;; the License, or (at your option) any later version.              
;;                                                                  
;; This program is distributed in the hope that it will be useful,  
;; but WITHOUT ANY WARRANTY; without even the implied warranty of   
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
;; GNU General Public License for more details.                     
;;                                                                  
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, contact:
;;
;; Free Software Foundation           Voice:  +1-617-542-5942
;; 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
;; Boston, MA  02111-1307,  USA       gnu@gnu.org

;;; Commentary:
;;
;;Soundscrape is a programmatic framework for modular synthesis.
;;
;;See @uref{http://ambient.2y.net/soundscrape/} for more information.
;;
;;This module exports no symbols of its own.
;;
;;Other modules within soundscrape include the following:
;;
;;@itemize
;;@item @code{@ref{(soundscrape core)}}
;;@item @code{@ref{(soundscrape elements)}}
;;@item @code{@ref{(soundscrape operators)}}
;;@item @code{@ref{(soundscrape misc)}}
;;@item @code{@ref{(soundscrape streams)}}
;;@item @code{@ref{(soundscrape ui)}}
;;@end itemize
;;
;;The first five are automatically included by @code{(soundscrape)}; If
;;you want @code{(soundscrape ui)} you'll have to include it manually.
;;
;;For more information, see the help files of the individual modules.
;;
;;; Code:

(define-module (soundscrape)
  :use-module (soundscrape core)
  :use-module (soundscrape operators)
  :use-module (soundscrape misc)
  :use-module (soundscrape elements)
  :use-module (soundscrape streams)
  :use-module (gnome gobject gw-utils))

(re-export-module (soundscrape core))
(re-export-module (soundscrape elements))
(re-export-module (soundscrape ugens))
(re-export-module (soundscrape operators))
(re-export-module (soundscrape misc))
(re-export-module (soundscrape streams))
