;; Soundscrape
;; Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>

;; This program is free software; you can redistribute it and/or    
;; modify it under the terms of the GNU General Public License as   
;; published by the Free Software Foundation; either version 2 of   
;; the License, or (at your option) any later version.              
;;                                                                  
;; This program is distributed in the hope that it will be useful,  
;; but WITHOUT ANY WARRANTY; without even the implied warranty of   
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
;; GNU General Public License for more details.                     
;;                                                                  
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, contact:
;;
;; Free Software Foundation           Voice:  +1-617-542-5942
;; 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
;; Boston, MA  02111-1307,  USA       gnu@gnu.org

;;; Commentary:
;;
;;This module contains some gstreamer-related convenience routines for
;;internal use.
;;
;;; Code:

(define-module (soundscrape gst-util)
  :use-module (gnome gstreamer)
  :export (filter-direction))

(use-modules ((srfi srfi-1)
              :select (filter)))

(define (filter-direction pads direction)
  "Filters @var{pads}, a list of either pads or pad templates, returning
only those pads that are in @var{direction} (either @code{src} or
@code{sink})."
  (filter
   (lambda (pad)
     (eq? (genum->symbol (get-direction pad)) direction))
   pads))
