;; Soundscrape
;; Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>

;; This program is free software; you can redistribute it and/or    
;; modify it under the terms of the GNU General Public License as   
;; published by the Free Software Foundation; either version 2 of   
;; the License, or (at your option) any later version.              
;;                                                                  
;; This program is distributed in the hope that it will be useful,  
;; but WITHOUT ANY WARRANTY; without even the implied warranty of   
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
;; GNU General Public License for more details.                     
;;                                                                  
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, contact:
;;
;; Free Software Foundation           Voice:  +1-617-542-5942
;; 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
;; Boston, MA  02111-1307,  USA       gnu@gnu.org

;;; Commentary:
;;
;;This module generates the glue code between guile and the C
;;soundscrape UI module.
;;
;;; Code:

(define-module (soundscrape gw-soundscrape-ui-spec)
  :use-module (g-wrap)
  :use-module (gnome gobject gw-spec-utils)
  :use-module (gnome gobject gw-gobject-spec)
  :use-module (gnome gtk gw-gtk-spec)
  :use-module (gnome gstreamer gw-gstreamer-spec))

(let ((ws (gw:new-wrapset "guile-gw-soundscrape-ui")))

  (gw:wrapset-set-guile-module! ws '(soundscrape gw-soundscrape-ui))
  (gw:wrapset-depends-on ws "guile-gnome-gw-standard")
  (gw:wrapset-depends-on ws "guile-gnome-gw-glib")
  (gw:wrapset-depends-on ws "guile-gnome-gw-gobject")
  (gw:wrapset-depends-on ws "guile-gnome-gw-gtk")
  (gw:wrapset-depends-on ws "guile-gnome-gw-gstreamer")

  (gw:wrapset-add-cs-declarations!
   ws
   (lambda (wrapset client-wrapset)
     (if (not client-wrapset)
         '("#include \"ss-ui.h\"\n")
         '())))

  (gobject:gwrap-object ws "SSSliderControl" "SS_TYPE_SLIDER_CONTROL")

  (gobject:gwrap-set-all-types-used ws))
