/* GStreamer
 * Copyright (C) 1999,2000 Erik Walthinsen <omega@cse.ogi.edu>
 *                    2000 Wim Taymans <wtay@chello.be>
 *
 * gst-binary-op.h: Header for SSBinaryOp element
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */

#ifndef __SS_BINARY_OP_H__
#define __SS_BINARY_OP_H__


#include <gst/gst.h>

#include "ss.h"


G_BEGIN_DECLS;


#define SS_TYPE_BINARY_OP \
  (ss_binary_op_get_type())
#define SS_BINARY_OP(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),SS_TYPE_BINARY_OP,SSBinaryOp))
#define SS_BINARY_OP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),SS_TYPE_BINARY_OP,SSBinaryOpClass))
#define SS_IS_BINARY_OP(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),SS_TYPE_BINARY_OP))
#define SS_IS_BINARY_OP_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),SS_TYPE_BINARY_OP))


typedef struct _SSBinaryOp             SSBinaryOp;
typedef struct _SSBinaryOpClass        SSBinaryOpClass;


struct _SSBinaryOp {
    SSElement	element;

    GstPad	*srcpad;
  
    GstPad	*sink[2];

    gfloat 	(*do_op_cc) (gfloat a, gfloat b);
    void 	(*do_op_aa) (gfloat *a, gfloat *b, gint how_many);
    void 	(*do_op_ac) (gfloat *a, gfloat b, gint how_many);
    void 	(*do_op_ca) (gfloat a, gfloat *b, gint how_many);
};

struct _SSBinaryOpClass {
    SSElementClass parent_class;
};


GType    ss_binary_op_get_type (void);
gboolean init_ss_binary_op (GstPlugin *plugin);


G_END_DECLS;


#endif /* __SS_PLUS_H__ */
