/* Soundscrape
 * ss-buffer-pool.h: Buffer pool for soundscrape buffers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef __SS_BUFFER_POOL_H__
#define __SS_BUFFER_POOL_H__

#include <gst/gstbuffer.h>


#define SS_BUFFER_DATA(buf) ((gfloat*)GST_BUFFER_DATA (buf))
#define SS_BUFFER_GET_FRAMES(buf) (GST_BUFFER_SIZE (buf)/sizeof(gfloat))
#define SS_BUFFER_SET_FRAMES(buf, frames) GST_BUFFER_SIZE (buf) = (frames) * sizeof(gfloat)


GstBufferPool*	ss_buffer_pool_set_buffer_frames (guint nframes);

GstData*	ss_buffer_new (void);
GstData*	ss_buffer_new_constant_val (gfloat val);
GstData*	ss_buffer_new_lin_interp (gfloat start, gfloat end);


#endif /* __SS_BUFFER_POOL_H__ */
