/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-control.h: Control data in a GstBuffer
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */

#include "ss-control.h"


GstData*
ss_control_new (SSPad *pad)
{
    GstBuffer *buffer = gst_buffer_new ();

    GST_BUFFER_FLAG_SET (buffer, GST_BUFFER_DONTFREE);
    GST_BUFFER_FLAG_SET (buffer, SS_BUFFER_FLAG_CONTROL);
    GST_BUFFER_DATA (buffer) = (guint8*)&(pad->value);
    
    return GST_DATA (buffer);
}
