/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-control.h: A GstBuffer for control-rate data
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */

#ifndef __SS_CONTROL_H__
#define __SS_CONTROL_H__

#include <gst/gstbuffer.h>
#include "ss.h"

G_BEGIN_DECLS


enum
{
    SS_BUFFER_FLAG_CONTROL = GST_BUFFER_KEY_UNIT
};

#define SS_IS_CONTROL(buf)	(GST_DATA_FLAG_IS_SET (buf, SS_BUFFER_FLAG_CONTROL))
#define SS_CONTROL_VALUE(buf)	(*(gfloat*)GST_BUFFER_DATA (buf))

GstData*	ss_control_new	 		(SSPad *pad);
#define		ss_control_set_pad(ssc, pad)                \
G_STMT_START {                                              \
  GST_BUFFER_DATA (ssc) = (guint8*)&(((SSPad*)pad)->value); \
} G_STMT_END


G_END_DECLS

#endif /* __SS_CONTROL_H__ */
