/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-enveloptor.h: Sequenced, triggered control data
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */

#ifndef __SS_ENVELOPTOR_H__
#define __SS_ENVELOPTOR_H__

#include "ss.h"
#include <libguile.h> /* yikes, scheme in the processing loop... */

G_BEGIN_DECLS;


#define SS_TYPE_ENVELOPTOR \
  (ss_enveloptor_get_type())
#define SS_ENVELOPTOR(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),SS_TYPE_ENVELOPTOR,SSEnveloptor))
#define SS_ENVELOPTOR_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),SS_TYPE_ENVELOPTOR,SSEnveloptorClass))
#define SS_IS_ENVELOPTOR(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),SS_TYPE_ENVELOPTOR))
#define SS_IS_ENVELOPTOR_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),SS_TYPE_ENVELOPTOR))


typedef struct _SSEnveloptor             SSEnveloptor;
typedef struct _SSEnveloptorClass        SSEnveloptorClass;


struct _SSEnveloptor {
    SSElement	element;

    GstPad	*src;
    GstPad	*trigger;
    GstPad	*input;

    gint	nstages;
    gfloat	*levels;
    gfloat	*times;
    gint	 sustain;
    SSWarp	 warp;    

    gint	 count; /* countdown to next level change */
    gint	 stage; /* stage of the envelope */
    gfloat	 level; /* the current envelope level */

    gfloat	 grow;
};

struct _SSEnveloptorClass {
    SSElementClass parent_class;
};


GType    ss_enveloptor_get_type (void);
gboolean init_ss_enveloptor (GstPlugin *plugin);

void	 ss_enveloptor_set_envelope (SSEnveloptor *e, SCM envelope);


G_END_DECLS;

#endif /* __SS_PLUS_H__ */
