/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-ladspa.h: Wrap LADSPA plugins as SSElements
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 *
 * Based on gstladspa.h:
 * Copyright (C) 2001 Steve Baker, <stevebaker_org@yahoo.co.uk>.
 */


#ifndef __SS_LADSPA_H__
#define __SS_LADSPA_H__


#include <gst/gst.h>
#include "ss.h"
#include <ladspa.h>


G_BEGIN_DECLS

typedef struct _SSLADSPA SSLADSPA;
typedef struct _SSLADSPAClass SSLADSPAClass;

struct _SSLADSPA {
    SSElement element;

    LADSPA_Descriptor *descriptor;
    LADSPA_Handle *handle;

    gfloat *controls;
  
    GstPad *add, *mul;

    GstPad **sinks, **srcs;
    GstData **controls_in, **controls_out;
    GstData **buffers_in, **buffers_out;

    gboolean activated;

    gint64 timestamp;
    gboolean inplace_broken;
};

struct _SSLADSPAClass {
    SSElementClass parent_class;

    LADSPA_Descriptor *descriptor;

    gint numports;
    gint numsinks, numsrcs;
    gint numaudio_sinks, numaudio_srcs;
    gint numcontrol_sinks, numcontrol_srcs;

    gint *sink_ports, *src_ports;
    gint *audio_sinks, *audio_srcs;
    gint *control_sinks, *control_srcs;
};


gboolean init_ss_ladspa (GstPlugin *plugin);


G_END_DECLS

#endif /* __SS_LADSPA_H__ */
