/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-plug.h: Receive data from external sources
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */


#ifndef __SS_PLUG_H__
#define __SS_PLUG_H__


#include <gst/gst.h>
#include "ss.h"

G_BEGIN_DECLS

#define SS_TYPE_PLUG \
  (ss_plug_get_type())
#define SS_PLUG(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),SS_TYPE_PLUG,SSPlug))
#define SS_PLUG_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),SS_TYPE_PLUG,SSPlugClass))
#define SS_IS_PLUG(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),SS_TYPE_PLUG))
#define SS_IS_PLUG_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),SS_TYPE_PLUG))

typedef struct _SSPlug SSPlug;
typedef struct _SSPlugClass SSPlugClass;

struct _SSPlug {
    SSElement	 element;

    gfloat	 value;
    gfloat	 lag_time;
    gfloat	 last_value;
    gfloat	 multiplier;

    GstPad	*src;
};

struct _SSPlugClass {
    SSElementClass parent_class;
};

GType	ss_plug_get_type (void);
gboolean init_ss_plug (GstPlugin *plugin);

G_END_DECLS

#endif /* __SS_PLUG_H__ */
