/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-sequencer.h: Sequenced, triggered control data
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */

#ifndef __SS_SEQUENCER_H__
#define __SS_SEQUENCER_H__

#include "ss.h"
#include <libguile.h> /* yikes, scheme in the processing loop... */

G_BEGIN_DECLS;


#define SS_TYPE_SEQUENCER \
  (ss_sequencer_get_type())
#define SS_SEQUENCER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),SS_TYPE_SEQUENCER,SSSequencer))
#define SS_SEQUENCER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),SS_TYPE_SEQUENCER,SSSequencerClass))
#define SS_IS_SEQUENCER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),SS_TYPE_SEQUENCER))
#define SS_IS_SEQUENCER_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),SS_TYPE_SEQUENCER))


typedef struct _SSSequencer             SSSequencer;
typedef struct _SSSequencerClass        SSSequencerClass;


struct _SSSequencer {
    SSElement	element;

    GstPad	*src;
  
    GstPad	*trigger;
    SCM		 lambda;
    gboolean	 need_call;
};

struct _SSSequencerClass {
    SSElementClass parent_class;
};


GType    ss_sequencer_get_type (void);
gboolean init_ss_sequencer (GstPlugin *plugin);


G_END_DECLS;

#endif /* __SS_PLUS_H__ */
