/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-slider-control.h: Control a soundscrape parameter with a slider bar
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */


#ifndef __SS_SLIDER_CONTROL_H__
#define __SS_SLIDER_CONTROL_H__


#include <gst/gst.h>
#include <gtk/gtk.h>
#include "ss.h"

G_BEGIN_DECLS

#define SS_TYPE_SLIDER_CONTROL \
  (ss_slider_control_get_type())
#define SS_SLIDER_CONTROL(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),SS_TYPE_SLIDER_CONTROL,SSSliderControl))
#define SS_SLIDER_CONTROL_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),SS_TYPE_SLIDER_CONTROL,SSSliderControlClass))
#define SS_IS_SLIDER_CONTROL(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),SS_TYPE_SLIDER_CONTROL))
#define SS_IS_SLIDER_CONTROL_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),SS_TYPE_SLIDER_CONTROL))

typedef struct _SSSliderControl SSSliderControl;
typedef struct _SSSliderControlClass SSSliderControlClass;

struct _SSSliderControl {
    GtkVBox	 vbox;

    GtkObject	*adjustment;
    GtkWidget	*scale;
    GtkWidget	*value_label;
    GtkWidget	*name_label;

    gchar	*name;
    gfloat	 value;
    gfloat	 lower;
    gfloat	 upper;
    SSWarp	 warp;

    /* for the exponential warp */
    gfloat	 a;
    gfloat	 b;

    SSElement	*model;
};

struct _SSSliderControlClass {
    GtkVBoxClass parent_class;
};

GType	ss_slider_control_get_type (void);

G_END_DECLS

#endif /* __SS_SLIDER_CONTROL_H__ */
