/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss-unary-op.c: Unary operations
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */

#ifndef __SS_UNARY_OP_H__
#define __SS_UNARY_OP_H__


#include <gst/gst.h>

#include "ss.h"


G_BEGIN_DECLS;


#define SS_TYPE_UNARY_OP \
  (ss_unary_op_get_type())
#define SS_UNARY_OP(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),SS_TYPE_UNARY_OP,SSUnaryOp))
#define SS_UNARY_OP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),SS_TYPE_UNARY_OP,SSUnaryOpClass))
#define SS_IS_UNARY_OP(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),SS_TYPE_UNARY_OP))
#define SS_IS_UNARY_OP_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),SS_TYPE_UNARY_OP))


typedef struct _SSUnaryOp             SSUnaryOp;
typedef struct _SSUnaryOpClass        SSUnaryOpClass;


struct _SSUnaryOp {
    SSElement	element;

    GstPad	*srcpad;
  
    GstPad	*sink;

    gfloat 	(*do_op_c) (gfloat a);
    void 	(*do_op_a) (gfloat *a, gint how_many);
};

struct _SSUnaryOpClass {
    SSElementClass parent_class;
};


GType    ss_unary_op_get_type (void);
gboolean init_ss_unary_op (GstPlugin *plugin);


G_END_DECLS;


#endif /* __SS_PLUS_H__ */
