/* Soundscrape
 * Copyright (C) 2003 Andy Wingo <wingo at pobox dot com>
 *
 * ss.h: Initialization for the Soundscrape module
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 */

#ifndef __SS_H__
#define __SS_H__

#include <gst/gst.h>

/* #define SS_TYPE_PARANOID */

#include "ss-buffer-pool.h"
#include "ss-pad.h"
#include "ss-control.h"
#include "ss-element.h"


#define SS_TYPE_MAKE_BOILERPLATE(func_name, parent_type, type_string, class_type, instance_type, class_init, instance_init) \
GType                                                                           \
func_name (void)                                                                \
{                                                                               \
  static GType type = 0;                                                        \
                                                                                \
  if (!type) {                                                                  \
    static const GTypeInfo info = {                                             \
      sizeof(class_type),                                                       \
      (GBaseInitFunc)NULL,                                                      \
      (GBaseFinalizeFunc)NULL,                                                  \
      (GClassInitFunc)class_init,                                               \
      (GClassFinalizeFunc)NULL,                                                 \
      NULL, /* class data */                                                    \
      sizeof(instance_type),                                                    \
      0, /* n_preallocs */                                                      \
      (GInstanceInitFunc)instance_init                                          \
    };                                                                          \
    type = g_type_register_static (parent_type, type_string, &info, 0);         \
  }                                                                             \
  return type;                                                                  \
}


#define SS_TYPE_WARP (ss_warp_get_type())

typedef enum {
  SS_WARP_LINEAR = 1,
  SS_WARP_EXPONENTIAL,
  SS_WARP_SINE,
  SS_WARP_CURVE,
  SS_WARP_WELCH,
  SS_WARP_STEP,
  SS_WARP_QUADRATIC,
  SS_WARP_CUBIC
} SSWarp;


extern GstPlugin *ss_plugin;

extern GstBufferPool *ss_buffer_pool;


GType ss_warp_get_type (void);


#endif

