;; Soundscrape
;; Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>

;; This program is free software; you can redistribute it and/or    
;; modify it under the terms of the GNU General Public License as   
;; published by the Free Software Foundation; either version 2 of   
;; the License, or (at your option) any later version.              
;;                                                                  
;; This program is distributed in the hope that it will be useful,  
;; but WITHOUT ANY WARRANTY; without even the implied warranty of   
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
;; GNU General Public License for more details.                     
;;                                                                  
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, contact:
;;
;; Free Software Foundation           Voice:  +1-617-542-5942
;; 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
;; Boston, MA  02111-1307,  USA       gnu@gnu.org

;;; Commentary:
;;
;;The graphical interface elements of soundscrape.
;;
;;This module does not export any bindings of its own. It does,
;;however, re-export the bindings from the following modules:
;;
;;@table @code
;;@item @ref{(soundscrape ui main-window)}
;;The main window
;;
;;@item @ref{(soundscrape ui listener)}
;;Auxiliary listener windows
;;
;;@item @ref{(soundscrape ui source-window)}
;;Source file windows
;;
;;@item @ref{(soundscrape ui control-window)}
;;Graphical control windows
;;
;;@item @ref{(soundscrape ui controls)}
;;Controls (that go in control windows)
;;@end table
;;
;;For more information, see the help of the individual modules.
;;
;;; Code:

(define-module (soundscrape ui)
  :use-module (soundscrape config)

  :use-module (soundscrape ui help)
  :use-module (soundscrape ui main-window)
;  :use-module (soundscrape ui listener-window)
  :use-module (soundscrape ui source-window)
  :use-module (soundscrape ui control-window)
  :use-module (soundscrape ui controls)

  :use-module (gnome gobject gw-utils)
  :use-module (gnome gnome))

(gnome-program-init "soundscrape" "0.1")

;; as an excessively nasty hack, let's remove the definition of render
;; put in the root module by (gnome gtk).
(module-remove! the-root-module 'render)

(re-export-module (soundscrape ui help))
(re-export-module (soundscrape ui main-window))
;(re-export-module (soundscrape ui listener-window))
(re-export-module (soundscrape ui source-window))
(re-export-module (soundscrape ui control-window))
(re-export-module (soundscrape ui controls))
