;; Soundscrape
;; Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>

;; This program is free software; you can redistribute it and/or    
;; modify it under the terms of the GNU General Public License as   
;; published by the Free Software Foundation; either version 2 of   
;; the License, or (at your option) any later version.              
;;                                                                  
;; This program is distributed in the hope that it will be useful,  
;; but WITHOUT ANY WARRANTY; without even the implied warranty of   
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
;; GNU General Public License for more details.                     
;;                                                                  
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, contact:
;;
;; Free Software Foundation           Voice:  +1-617-542-5942
;; 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
;; Boston, MA  02111-1307,  USA       gnu@gnu.org

;;; Commentary:
;;
;;A window to hold graphical synthesis controls.
;;
;;; Code:

(define-module (soundscrape ui control-window)
  :use-module (ice-9 optargs)
  :use-module (gnome gtk)
  :use-module (gnome gstreamer)
  ;:use-module (soundscrape ui util)

  :export (gui-control-window))

(define-class <ss-gui-control-window> (<gtk-window>)
  hbox)

(define-method (gtype-instance:initialize (w <ss-gui-control-window>))
  ;; fixme: connect to 'removed signal to kill window when all children
  ;; are gone
  (set w 'type 'toplevel)
  (show w)
  (set-default-size w 30 150)
  (slot-set! w 'hbox (gtk-hbox-new #t 5))
  (let ((hbox (slot-ref w 'hbox)))
    (add w hbox)
    (show hbox)))

(define-method (add (w <ss-gui-control-window>) (control <gtk-widget>))
  "Usage: (add window control)

Add CONTROL to gui window WINDOW."
  (gtk-box-pack-start (hbox w) control #f #f 0))

(define* (gui-control-window name :key (width 30) (height 150))
  "Usage: (gui-window name :width w :height h)

Create a new gui window of the specified dimensions. If the dimensions
are not given, default to 30 by 150."
  (make <ss-gui-control-window> :title name))
