;; Soundscrape
;; Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>

;; This program is free software; you can redistribute it and/or    
;; modify it under the terms of the GNU General Public License as   
;; published by the Free Software Foundation; either version 2 of   
;; the License, or (at your option) any later version.              
;;                                                                  
;; This program is distributed in the hope that it will be useful,  
;; but WITHOUT ANY WARRANTY; without even the implied warranty of   
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
;; GNU General Public License for more details.                     
;;                                                                  
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, contact:
;;
;; Free Software Foundation           Voice:  +1-617-542-5942
;; 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
;; Boston, MA  02111-1307,  USA       gnu@gnu.org

;;; Commentary:
;;
;;A help tree for soundscrape.
;;
;;; Code:

(define-module (soundscrape ui help-tree)
  :use-module (gnome gtk) ; grr
  :use-module (soundscrape ui lazy-tree)
  :use-module (oop goops)
  :use-module (soundscrape util)
  :use-module (soundscrape ui stext gtk-text-buffer)
  :export (<ss-help-node> <ss-help-tree> the-help-tree)
  :re-export (append-node))

(define-class-with-docs <ss-help-node> (<ss-lazy-node>)
  "A node in a soundscrape help tree."
  (buffer
   :init-keyword :buffer
   :init-value #f))

(define-class-with-docs <ss-help-tree> (<ss-lazy-tree>)
  "A tree model for soundscrape's help.")

(define-with-docs the-help-tree
  "The tree for the help window."
  (make <ss-help-tree>))

(define-method (on-get-n-columns (obj <ss-help-tree>))
  3) ;; name, value, buffer

(define-method (on-get-column-type (obj <ss-help-tree>) index)
  (case index
    ((2) gtype:gboxed-scm)
    (else (next-method))))

(define-method (on-get-value (obj <ss-help-tree>) iter index)
  (case index
    ((2)
     (or (slot-ref iter 'buffer)
         (and=> (on-get-value obj iter 1)
                (lambda (stext)
                  ((lambda (buffer)
                     (slot-set! iter 'buffer buffer)
                     buffer)
                   (stext->gtk-text-buffer stext))))))
    (else
     (next-method))))
